package iet.jxufe.cn.android.musicplayer;

import java.util.List;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.widget.Spinner;
import android.widget.TextView;

public class MusicPlayActivity extends Activity {// ֲ棬ɿֵĲ
	private List<Music> musicList;//¼б
	private TextView titleView, singerView, currentTimeView, totalTimeView;// ʾϢǰʱ䡢ʱıʾ
	private SeekBar playProgress;// ϶
	private Spinner styleSpinner;//ѡ񲥷ʽб
	private ImageButton control;// /ͣť
	private ImageView picView;//ʾͼƬ
	private ServerReceiver serverReceiver;// պ̨͵Ĺ㲥Ĺ㲥
	private Music currentMusic;//¼ǰŵ
	private boolean isPause=false;//Ƿͣ
	private int currentPosition;//ǰֵ
	private int listType;//бֻͣǲбе	
	private String[] styles=new String[]{Constants.LIST_LOOP,Constants.SINGLE_LOOP,Constants.RANDOM_PLAY,Constants.OVER_FINISH};
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);//ȥ
		getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
				WindowManager.LayoutParams.FLAG_FULLSCREEN);//ȫʾ
		setContentView(R.layout.play_item);//		
		initView();// ʼ
	}
	public void initView() {//ִгʼ
		styleSpinner=(Spinner)findViewById(R.id.styleSpinner);
		styleSpinner.setAdapter(new ArrayAdapter<String>(this,R.layout.spinner_text,styles));
		styleSpinner.setOnItemSelectedListener(new SpinnerItemClickListener());
		picView=(ImageView)findViewById(R.id.picView);
		currentTimeView = (TextView) findViewById(R.id.currentTime);// ʾֵǰŵʱıؼ
		totalTimeView = (TextView) findViewById(R.id.totalTime);// ʾֵʱıؼ
		titleView = (TextView) findViewById(R.id.title);// ʾֱıؼ
		singerView = (TextView) findViewById(R.id.singer);// ʾݳߵıؼ
		playProgress = (SeekBar) findViewById(R.id.playProgress);// ʾǰֲŽȵĿؼ
		control = (ImageButton) findViewById(R.id.control);// ƲŻͣĿؼ
		playProgress.setOnSeekBarChangeListener(new MySeekBarChangeListener());// Ϊ϶¼
		serverReceiver = new ServerReceiver();//㲥
		IntentFilter filter = new IntentFilter();//ԽյĹ㲥
		filter.addAction(Constants.COMPLETE_ACTION);// ֲŽ¼
		filter.addAction(Constants.UPDATE_ACTION);// ½ȵĶ
		registerReceiver(serverReceiver, filter);//ע㲥		
		currentMusic = (Music) getIntent().getSerializableExtra("music");// ȡǰŵ
		if(currentMusic==null){//ǰΪ
			SharedPreferences musicPreferences=getSharedPreferences("music", Context.MODE_PRIVATE);
			currentPosition=musicPreferences.getInt("position", 0);
			listType=musicPreferences.getInt("listType", Constants.ALL_MUSIC);
			if(listType==Constants.ALL_MUSIC){//е
				musicList=Constants.musiclist;
			}else{//ǲб
				musicList=Constants.playlist;
			}
			currentMusic=musicList.get(currentPosition);//ȡǰ
			String styleString=musicPreferences.getString("style", Constants.LIST_LOOP);
			for(int i=0;i<styles.length;i++){
				if(styles[i].equalsIgnoreCase(styleString)){
					styleSpinner.setSelection(i);
					break;
				}
			}
			showInfo();//ʾϢ
			isPause=true;//
			control(null);
		}else{//ֱӲ
			currentPosition=getIntent().getIntExtra("position",0);//ĬΪһ
			listType=getIntent().getIntExtra("listType", Constants.ALL_MUSIC);//ȡбͣǴеֻǲбв
			playNewMusic();//
			if(listType==Constants.ALL_MUSIC){//е
				musicList=Constants.musiclist;
			}else{//ǲб
				musicList=Constants.playlist;
			}
		}		
		
	}
	public void showInfo(){
		totalTimeView.setText(MusicUtils.timeToString(currentMusic.getTime()));//ʾֵʱ
		titleView.setText("        " + currentMusic.getTitle() + "        ");// ʾ
		singerView.setText(currentMusic.getSinger());// ʾݳ
		Bitmap bitmap=MusicUtils.getAlbumPic(this, currentMusic);
		if(bitmap!=null){
			picView.setImageBitmap(bitmap);
		}else{
			picView.setImageResource(R.drawable.background);
		}
	}
	public void playNewMusic() {
		currentTimeView.setText(MusicUtils.timeToString(0));//ʾǰŵʱ䣬ĬΪ0
		showInfo();
		playProgress.setProgress(0);//Ϊ0
		control.setImageResource(R.drawable.pause);//ʾͣİť		
		// ͹㲥̨֪ͨ
		Intent controlIntent = new Intent(Constants.CONTROL_ACTION);
		controlIntent.putExtra("new", Constants.NEW);//һ
		controlIntent.putExtra("position",currentPosition);//ݵǰֵ
		controlIntent.putExtra("listType",listType);//б
		sendBroadcast(controlIntent);//͹㲥
		isPause=false;//ǷͣΪfalse
	}
	private class MySeekBarChangeListener implements OnSeekBarChangeListener {
		public void onProgressChanged(SeekBar seekBar, int progress,
				boolean fromUser) { // ȷͱ仯ʱø÷
		}
		public void onStartTrackingTouch(SeekBar seekBar) {// ʼ϶ʱ
		}
		public void onStopTrackingTouch(SeekBar seekBar) {// ϶ʱ			
			Intent seekIntent = new Intent(Constants.SEEKBAR_ACTION);//͹㲥֪ͨ϶仯
			seekIntent.putExtra("progress", seekBar.getProgress());//ǰĽȴݽȥ
			sendBroadcast(seekIntent);// ͹㲥
		}
	}
	private class ServerReceiver extends BroadcastReceiver {// 㲥ڽպ̨͵Ĺ㲥
		public void onReceive(Context context, Intent intent) {
			if(intent.getAction()==Constants.UPDATE_ACTION){//½ȵĹ㲥
				int position=intent.getIntExtra("position",0);//ȡֲŵλ				
				currentTimeView.setText(MusicUtils.timeToString(position));//ʾǰĲʱ
				playProgress.setProgress((int)(position*1.0/currentMusic.getTime()*100));//λüĽ
			}else if(intent.getAction()==Constants.COMPLETE_ACTION){//ֲɵ¼
				currentPosition=intent.getIntExtra("position", 0);//ȡǰŵֵ
				currentMusic=musicList.get(currentPosition);//ȡǰ
				showInfo();//ʾǰֵϢ
			}
		}
	}
	private class SpinnerItemClickListener implements OnItemSelectedListener{		
		public void onItemSelected(AdapterView<?> parent, View view,
				int position, long id) {			
			Intent styleIntent=new Intent(Constants.UPDATE_STYLE);
			styleIntent.putExtra("style",styles[position]);
			sendBroadcast(styleIntent);
		}
		public void onNothingSelected(AdapterView<?> parent) {			
		}		
	}
	public void chooseMusic(View view){//ѡť¼
		Intent intent=new Intent(this,MainActivity.class);
		startActivity(intent);
		this.finish();
	}
	public void first(View view) {// һװť¼
		currentPosition=0;
		currentMusic=musicList.get(currentPosition);
		playNewMusic();
	}
	public void pre(View view) {// ǰһװť¼
		currentPosition=(currentPosition-1+musicList.size())%musicList.size();
		currentMusic=musicList.get(currentPosition);
		playNewMusic();
	}
	public void control(View view) {// źͣť¼
		Intent controlIntent=new Intent(Constants.CONTROL_ACTION);//ֲźͣ
		if(!isPause){//ڲ״̬͹㲥֪ͨͣ
			controlIntent.putExtra("control",Constants.PAUSE);
			control.setImageResource(R.drawable.play);//ıͼ
		}else{//ͣ״̬͹㲥֪ͨ
			controlIntent.putExtra("control",Constants.PLAY);
			control.setImageResource(R.drawable.pause);//ıͼ
		}
		isPause=!isPause;
		sendBroadcast(controlIntent);//͹㲥
	}
	public void next(View view) {// һװť¼
		currentPosition=(currentPosition+1)%musicList.size();
		currentMusic=musicList.get(currentPosition);
		playNewMusic();
	}
	public void last(View view) {// һװť¼
		currentPosition=musicList.size()-1;
		currentMusic=musicList.get(currentPosition);
		playNewMusic();
	}
	protected void onDestroy() {//ʱȡ㲥ע
		if (serverReceiver != null) {
			unregisterReceiver(serverReceiver);// Activityʱȡע
		}
		super.onDestroy();
	}
}
