package iet.jxufe.cn.android.musicplayer;
import java.util.List;
import java.util.Random;
import java.util.Timer;
import java.util.TimerTask;

import android.app.Notification;
import android.app.Notification.Builder;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.graphics.BitmapFactory;
import android.media.MediaPlayer;
import android.media.MediaPlayer.OnCompletionListener;
import android.os.IBinder;
public class MusicService extends Service {	
	private List<Music> musicList;//б
	private int position;//ǰֵ
	private MediaPlayer mediaPlayer;//ý岥
	private ActivityReceiver activityReceiver;//㲥
	private Music currentMusic;//ǰŵ		
	private Timer timer;//ʱ
	private int listType;//б
	private String styleString=Constants.LIST_LOOP;//ֲʽ,Ĭбѭ
	public void onCreate() {//	
		mediaPlayer=new MediaPlayer();
		activityReceiver=new ActivityReceiver();
		IntentFilter filter=new IntentFilter();//Intent
		filter.addAction(Constants.CONTROL_ACTION);//ֲŵĶźͣ
		filter.addAction(Constants.SEEKBAR_ACTION);//ıֲŽ
		filter.addAction(Constants.UPDATE_STYLE);//ıֲʽ
		registerReceiver(activityReceiver, filter);//ע㲥
		super.onCreate();
	}	
	public IBinder onBind(Intent intent) {		
		return null;
	}
	private class ActivityReceiver extends BroadcastReceiver{//ȡǰ̨͵Ĺ㲥
		public void onReceive(Context context, Intent intent) {			
			if(intent.getAction()==Constants.CONTROL_ACTION){//յƲŵĹ㲥ʼ֡ͣţ
				int isNew=intent.getIntExtra("new", -1);
				if(isNew!=-1){//һ
					listType=intent.getIntExtra("listType",Constants.ALL_MUSIC);
					if(listType==Constants.ALL_MUSIC){//е
						musicList=Constants.musiclist;
					}else{//ǲб
						musicList=Constants.playlist;
					}
					position=intent.getIntExtra("position", 0);
					currentMusic=musicList.get(position);//ȡǰҪŵ
					preparedAndPlay(currentMusic);//׼
				}else{
					int control=intent.getIntExtra("control",-1);
					if(control==Constants.PAUSE){//ʾҪͣ
						mediaPlayer.pause();//ͣ
						timer.cancel();//ȡʱ
					}else if(control==Constants.PLAY){//ʾ
						mediaPlayer.start();
						startTimer();//ʱ
					}
				}
			}else if(intent.getAction()==Constants.SEEKBAR_ACTION){
				int progress=intent.getIntExtra("progress",0);//ȡݵĽ
				int position=(int)(currentMusic.getTime()*progress*1.0/100);//תӦʱλ
				mediaPlayer.seekTo(position);//תָλü				
			}else if(intent.getAction()==Constants.UPDATE_STYLE){
				styleString=intent.getStringExtra("style");	
				SharedPreferences musicPreferences=getSharedPreferences("music", Context.MODE_PRIVATE);
				Editor editor=musicPreferences.edit();//ȡ༭
				editor.putString("style", styleString);				
				editor.commit();//ύ
			}
		}		
	}
	public void preparedAndPlay(Music music){// ׼						
		try{
			mediaPlayer.reset();//ý岥
			mediaPlayer.setDataSource(music.getUrl());//ֲŵ·					
			mediaPlayer.prepare();// ׼
			mediaPlayer.start();// 
			startTimer();//ʱ
			sendNotification();//͹㲥
			saveInfo();//
			mediaPlayer.setOnCompletionListener(new OnCompletionListener() {//ֲŽ¼					
				public void onCompletion(MediaPlayer mp) {//ֲɺ󣬸õĲͽвţ֪ͨǰ̨ı
					if(!Constants.OVER_FINISH.equalsIgnoreCase(styleString)){//ǲŽֹͣ
						if(Constants.LIST_LOOP.equalsIgnoreCase(styleString)){
							position=(position+1)%musicList.size();//Զһ
						}else if(Constants.RANDOM_PLAY.equalsIgnoreCase(styleString)){
							position=new Random().nextInt(musicList.size());
						}
						currentMusic=musicList.get(position);//ȡǰ
						preparedAndPlay(currentMusic);//׼
						Intent intent=new Intent(Constants.COMPLETE_ACTION);
						intent.putExtra("position", position);
						sendBroadcast(intent);//͹㲥	
					}else{
						stopSelf();//
					}									
				}
			});
		}catch(Exception ex){
			ex.printStackTrace();
		}			
	}
	public void saveInfo(){//Ϣ
		SharedPreferences musicPreferences=getSharedPreferences("music", Context.MODE_PRIVATE);
		Editor editor=musicPreferences.edit();//ȡ༭
		editor.putInt("listType",listType);//б
		editor.putInt("position",position);//ֵλ
		editor.commit();//ύ
	}
	public void sendNotification(){//̨֪ͨ
		NotificationManager notificationManager=(NotificationManager)getSystemService(Service.NOTIFICATION_SERVICE);//ȡ֪ͨ
		Builder builder=new Notification.Builder(this);//֪ͨ
		builder.setAutoCancel(false);//֪ͨԶΪfalse
		builder.setTicker("ֲ");//һγʱʾ״̬֪ͨʾϢ
		builder.setSmallIcon(R.drawable.music);//֪ͨСͼ
		builder.setLargeIcon(BitmapFactory.decodeResource(getResources(),R.drawable.largeicon));//֪ͨĴͼ		
		builder.setContentTitle("ڲ");//֪ͨݵı
		builder.setContentText(currentMusic.getTitle()+"  "+currentMusic.getSinger());//֪ͨ
		Intent intent=new Intent("iet.jxufe.cn.android.music_play");//֪ͨҳ
		PendingIntent pIntent=PendingIntent.getActivity(this,0, intent, 0);
		builder.setContentIntent(pIntent);//֪ͨĳ
		notificationManager.notify(0x11, builder.build());//֪ͨ
	}	
	public void startTimer(){//ʱ
		timer=new Timer();//ʱ
		timer.schedule(new TimerTask() {//ʱִе
			public void run() {//͹㲥֪ͨǰ̨
				Intent updateIntent=new Intent(Constants.UPDATE_ACTION);
				updateIntent.putExtra("position", mediaPlayer.getCurrentPosition());
				sendBroadcast(updateIntent);
			}
		}, 0,1000);//ÿ1뷢һ		
	}
	public void onDestroy() {//ʱø÷		
		if(mediaPlayer!=null){//ֲ
			mediaPlayer.reset();
		}
		if(activityReceiver!=null){//ȡ㲥
			unregisterReceiver(activityReceiver);
		}
		super.onDestroy();
	}
}
