package iet.jxufe.cn.android.musicplayer;

import java.io.FileDescriptor;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.ParcelFileDescriptor;
import android.provider.MediaStore;

public class MusicUtils {
	public static List<Music> getMusicData(Context context) {
		ContentResolver mResolver = context.getContentResolver();// ȡݽ
		if (mResolver != null) {// ȡи
			// һʾϵͳṩߵURI
			// ڶʾҪȡеϢ
			// ʾѯ
			// ĸʾеռλֵ
			// ʾѯʽ
			Cursor cursor = mResolver.query(
					MediaStore.Audio.Media.EXTERNAL_CONTENT_URI, null, null,
					null, MediaStore.Audio.Media.DEFAULT_SORT_ORDER);
			return cursorToList(cursor, context);

		}
		return null;
	}

	public static List<Music> cursorToList(Cursor cursor, Context context) {
		if (cursor == null || cursor.getCount() == 0) {
			return null;
		}
		List<Music> musicList = new ArrayList<Music>();// ϣڴ
		while (cursor.moveToNext()) {
			Music m = new Music();// ֶ
			String title = cursor.getString(cursor
					.getColumnIndex(MediaStore.Audio.Media.TITLE));// ȡֱ
			String artist = cursor.getString(cursor
					.getColumnIndex(MediaStore.Audio.Media.ARTIST));// ȡ
			if ("<unknown>".equals(artist)) {
				artist = "δ֪";
			}
			String album = cursor.getString(cursor
					.getColumnIndex(MediaStore.Audio.Media.ALBUM));// ȡר
			int album_id = cursor.getInt(cursor
					.getColumnIndex(MediaStore.Audio.Media.ALBUM_ID));			
			long size = cursor.getLong(cursor
					.getColumnIndex(MediaStore.Audio.Media.SIZE));// ȡִС
			int time = cursor.getInt(cursor
					.getColumnIndex(MediaStore.Audio.Media.DURATION));// ȡֳʱ䣬λΪ
			String url = cursor.getString(cursor
					.getColumnIndex(MediaStore.Audio.Media.DATA));// ȡֱ·
			String name = cursor.getString(cursor
					.getColumnIndex(MediaStore.Audio.Media.DISPLAY_NAME));// ȡ׺
			String sub = name.substring(name.lastIndexOf(".") + 1);
			// ȡļչ
			if (sub.equals("mp3") && time > 50000) {// MP3βҳȴ5				
				m.setTitle(title);// 
				m.setSinger(artist);// ݳ
				m.setAlbum(album);// ר
				m.setAlbum_id(album_id);// רı
				m.setSize(size);// ĴС
				m.setTime(time);// ʱ
				m.setUrl(url);// ŵ·
				m.setName(name);// ׺
				musicList.add(m);// ӵ
			}
		}
		cursor.close();// رα
		return musicList;
	}

	public static String timeToString(int time) {// ʱʽתתɷʽ
		int temp = time / 1000;// ת
		int minute = temp / 60;// һжٷ
		int second = temp % 60;// Щֺ󣬻ʣ
		return String.format("%02d:%02d", minute, second);// Էʽʾ
	}

	public static List<Music> getDataFromDB(SQLiteDatabase db) {
		List<Music> musics = new ArrayList<Music>();
		Cursor cursor = db.rawQuery("select * from music_tb", null);
		if (cursor == null || cursor.getCount() == 0) {
			return musics;
		}
		while (cursor.moveToNext()) {
			Music music = new Music();
			music.setTitle(cursor.getString(cursor.getColumnIndex(("title"))));
			music.setSinger(cursor.getString(cursor.getColumnIndex("artist")));
			music.setAlbum(cursor.getString(cursor.getColumnIndex("album")));
			music.setAlbum_id(cursor.getInt(cursor.getColumnIndex("album_id")));
			music.setUrl(cursor.getString(cursor.getColumnIndex("url")));
			music.setTime(cursor.getInt(cursor.getColumnIndex("time")));
			musics.add(music);
		}
		return musics;
	}	
	public static Bitmap getAlbumPic(Context context, Music music) {
		ContentResolver mResolver = context.getContentResolver();// ȡݽ
		Uri uri = ContentUris.withAppendedId(Constants.ALBUM_URL, music.getAlbum_id());
		try {
			InputStream inputStream = mResolver.openInputStream(uri);
			return BitmapFactory.decodeStream(inputStream);
		} catch (FileNotFoundException ex) {// ׳쳣
			try {
				ParcelFileDescriptor pfd = mResolver.openFileDescriptor(uri, "r");
				if (pfd != null) {
					FileDescriptor fd = pfd.getFileDescriptor();
					Bitmap bitmap = BitmapFactory.decodeFileDescriptor(fd);
					return bitmap;
				}
			} catch (Exception e) {
				return null;
			}			
			return null;
		}
	}
}
